--- old/usr/src/lib/pkcs11/pkcs11_softtoken/common/softKeysUtil.c	Fri Jul  6 15:55:10 2018
+++ new/usr/src/lib/pkcs11/pkcs11_softtoken/common/softKeysUtil.c	Fri Jul  6 15:55:10 2018
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2018, Joyent, Inc.
  */
 
 #include <pthread.h>
@@ -822,26 +823,11 @@
 	(void) memcpy(keybuf, A, keysize);
 
 cleanup:
-	if (A) {
-		bzero(A, Alen);
-		free(A);
-	}
-	if (Ai) {
-		bzero(Ai, AiLen);
-		free(Ai);
-	}
-	if (B) {
-		bzero(B, Blen);
-		free(B);
-	}
-	if (D) {
-		bzero(D, Dlen);
-		free(D);
-	}
-	if (I) {
-		bzero(I, Ilen);
-		free(I);
-	}
+	freezero(A, Alen);
+	freezero(Ai, AiLen);
+	freezero(B, Blen);
+	freezero(D, Dlen);
+	freezero(I, Ilen);
 	return (rv);
 }
 
@@ -1400,7 +1386,7 @@
 		keydata += hLen;
 	}
 	(void) soft_delete_object(session_p, hmac_key, B_FALSE, B_FALSE);
-	free(salt);
+	freezero(salt, params->ulSaltSourceDataLen);
 
 	return (rv);
 }
@@ -1535,14 +1521,12 @@
 cleanup_wrap:
 	if (padded_data != NULL && padded_len != plain_len) {
 		/* Clear buffer before returning to memory pool. */
-		(void) memset(padded_data, 0x0, padded_len);
-		free(padded_data);
+		freezero(padded_data, padded_len);
 	}
 
 	if ((hkey_p->class != CKO_SECRET_KEY) && (plain_data != NULL)) {
 		/* Clear buffer before returning to memory pool. */
-		(void) memset(plain_data, 0x0, plain_len);
-		free(plain_data);
+		freezero(plain_data, plain_len);
 	}
 
 	return (rv);
@@ -1822,8 +1806,7 @@
 
 	if (new_objp->class != CKO_SECRET_KEY) {
 		/* Clear buffer before returning to memory pool. */
-		(void) memset(plain_data, 0x0, plain_len);
-		free(plain_data);
+		freezero(plain_data, plain_len);
 	}
 
 	*phKey = (CK_OBJECT_HANDLE)new_objp;
@@ -1834,8 +1817,7 @@
 	/* The decrypted private key buffer must be freed explicitly. */
 	if ((new_objp->class != CKO_SECRET_KEY) && (plain_data != NULL)) {
 		/* Clear buffer before returning to memory pool. */
-		(void) memset(plain_data, 0x0, plain_len);
-		free(plain_data);
+		freezero(plain_data, plain_len);
 	}
 
 	/* sck and new_objp are indirectly free()d inside these functions */
